addHook("PlayerThink", function(player)
	if player.mo.friction ~= FRACUNIT
		player.mo.friction = FRACUNIT
	end
	if player.speed >= 50*FRACUNIT
	and not player.boostmode
		player.boostmode = true
		S_StartSound(player.mo, sfx_zoom)
	elseif player.speed < 50*FRACUNIT
	and P_IsObjectOnGround(player.mo)
	and player.boostmode
		player.boostmode = false
	end
	if player.boostmode
		player.charflags = $1|SF_RUNONWATER
    else
       player.charflags = $1 & ~SF_RUNONWATER
	end
	if player.boostmode
		if P_IsObjectOnGround(player.mo)
			P_SpawnSkidDust(player, player.speed/4)
		end
		P_Thrust(player.mo, player.mo.angle, FRACUNIT/10)
		if leveltime%5 == 0
			SpawnGhost(player)
		end
		if leveltime%15 == 0
			S_StartSound(player.mo, sfx_zoom)
		end
	end
	if not (player.cmd.buttons & BT_USE)
		player.pressedspin = false
	end
	if player.boostmode
		player.powers[pw_strong] = $|STR_SPIKE|STR_WALL
	else
		player.powers[pw_strong] = STR_NONE
	end
end)

addHook("SpinSpecial", function(player)
	if player.pressedspin return end
	if not (player.pflags & PF_SPINNING)
	and ((player.mo.eflags & MFE_JUSTHITFLOOR) or P_IsObjectOnGround(player.mo))
	and player.speed > 0*FRACUNIT
		player.pflags = $|PF_SPINNING
		player.mo.state = S_PLAY_ROLL
		player.pressedspin = true
		return true
	elseif (player.pflags & PF_SPINNING)
	and player.speed >= skins[player.mo.skin].runspeed
		player.pflags = $ & ~PF_SPINNING
		player.mo.state = S_PLAY_RUN
		player.pressedspin = true
		return true
	elseif (player.pflags & PF_SPINNING)
	and not P_IsObjectOnGround(player.mo)
		player.pflags = $ & ~PF_SPINNING
		player.mo.state = S_PLAY_FALL
		player.pressedspin = true
		return true
	elseif not P_IsObjectOnGround(player.mo)
		player.pflags = $|PF_JUMPED
		player.mo.state = S_PLAY_ROLL
		player.pressedspin = true
		return true
	else
		return false
	end
end)

addHook("PlayerSpawn", function(player)
	player.pressedspin = false
	player.dropdash = false
	player.boostmode = false
	player.dropdashspeed = 0
	player.fly = 0
	player.flyheight = 0
	player.flyuse = 0
end)

rawset(_G, "P_IsPlayerOnGround", function(player)
	if ((player.mo.eflags & MFE_JUSTHITFLOOR) or P_IsObjectOnGround(player.mo))
		return true
	else
		return false
	end
end)