rawset(_G, "SpawnGhost", function(player)
	local ghost = P_SpawnGhostMobj(player.mo)
	ghost.color = player.mo.color
	ghost.colorized = true
	ghost.fuse = 7
end)

addHook("JumpSpinSpecial", function(player)
	if player.mo.skin ~= "sonic" return end
	if (player.cmd.buttons & BT_USE)
	and not P_IsObjectOnGround(player.mo)
	and not player.dropdash
	and not (player.pflags & PF_THOKKED)
	and (player.pflags & PF_JUMPED)
		player.dropdash = true
		S_StartSound(player.mo, sfx_spndsh)
		player.dpanim = 12
		player.mo.state = S_PLAY_SPRING
		return true
	end
end)

addHook("AbilitySpecial", function(player)
	if player.mo.skin ~= "sonic" return end
	if (player.cmd.buttons & BT_JUMP)
	and not P_IsObjectOnGround(player.mo)
	and not player.dropdash
	and not (player.pflags & PF_THOKKED)
	and (player.pflags & PF_JUMPED)
		if P_LookForEnemies(player, true, true)
			local mobj = P_LookForEnemies(player)
			if mobj and mobj.valid
				player.mo.angle = R_PointToAngle2(player.mo.x, player.mo.y, mobj.x, mobj.y)
				P_SetOrigin(player.mo, mobj.x, mobj.y, mobj.z)
				if (mobj.flags & MF_ENEMY)
					P_SetObjectMomZ(player.mo, 15*FRACUNIT, false)
					player.mo.state = S_PLAY_JUMP
				end
			end
			return true
		elseif not P_LookForEnemies(player)
			return false
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo.skin ~= "sonic" return end
	if player.dropdash == nil
		player.dropdash = false
	end
	if player.dropdashspeed == nil
		player.dropdashspeed = 0*FRACUNIT
	end
	if player.boostmode == nil
		player.boostmode = false
	end
	if player.dropdashspeed > 50*FRACUNIT
		player.dropdashspeed = 50*FRACUNIT
	end
	if player.prevspeed == nil
		player.prevspeed = player.speed
	end
	if player.pressedspin == nil
		player.pressedspin = false
	end
	if player.dpanim == nil
		player.dpanim = 0
	end
	if player.dpanim > 0
		player.dpanim = $ - 1
	end
	if P_IsPlayerOnGround(player)
	and player.dpanim > 0
		player.dpanim = 0
	end
	if P_LookForEnemies(player)
		player.charability = CA_NONE
	elseif not P_LookForEnemies(player)
		player.charability = CA_DOUBLEJUMP
	end
	if player.dropdash
		player.dropdashspeed = $ + FRACUNIT
		if leveltime%5 == 0
			SpawnGhost(player)
		end
		if player.dpanim > 4 and player.dpanim < 8
			player.mo.state = S_PLAY_FALL
		elseif player.dpanim <= 4
			player.mo.state = S_PLAY_ROLL
		end
		if ((player.mo.eflags & MFE_JUSTHITFLOOR) or P_IsObjectOnGround(player.mo))
			P_Thrust(player.mo, player.mo.angle, player.dropdashspeed)
			S_StartSound(player.mo, sfx_zoom)
			player.pflags = $|PF_SPINNING
			player.mo.state = S_PLAY_ROLL
			player.dropdash = false
		end
		if not (player.cmd.buttons & BT_USE)
		and not ((player.mo.eflags & MFE_JUSTHITFLOOR) or P_IsObjectOnGround(player.mo))
			P_Thrust(player.mo, player.mo.angle, (player.dropdashspeed/2))
			P_SetObjectMomZ(player.mo, (player.dropdashspeed/3), false)
			S_StartSound(player.mo, sfx_zoom)
			player.pflags = $|PF_THOKKED
			player.dropdash = false
			player.mo.state = S_PLAY_ROLL
		end
		if (player.cmd.buttons & BT_JUMP)
		and not ((player.mo.eflags & MFE_JUSTHITFLOOR) or P_IsObjectOnGround(player.mo))
			P_SetObjectMomZ(player.mo, ((player.dropdashspeed/2) + 10*FRACUNIT), false)
			S_StartSound(player.mo, sfx_zoom)
			player.pflags = $|PF_THOKKED
			player.dropdash = false
			player.mo.state = S_PLAY_SPRING
		end
	end
	if not player.dropdash
	and player.dropdashspeed ~= 0
		player.dropdashspeed = 0*FRACUNIT
	end
end)

addHook("PlayerCanDamage", function(player)
	if player.boostmode
		return true
	end
end)